package PlayBot::sites::mixcloud;

use strict;
use warnings;

use LWP::UserAgent;
use JSON;
use Encode;


sub regex
{
    return qr#(^|[^!])https?://www.mixcloud.com/([a-zA-Z0-9-_]+/[a-zA-Z0-9-_]+)#;
}


sub get {
    shift;
	my $id = shift;
	my $url = 'https://api.mixcloud.com/'.$2;

	my $ua = LWP::UserAgent->new(
        timeout     => 30,
        env_proxy   => 1,
    );
	my $response = $ua->get($url);
	die($response->status_line) unless ($response->is_success);

	my $content = decode_json(encode('UTF-8', $response->decoded_content));
    my $infos = {
	    title       => $content->{'name'},
	    author      => $content->{'user'}->{'name'},
	    url         => $content->{'url'},
        duration    => $content->{'audio_length'},
        site        => 'mixcloud',
    };

	return %{ $infos };
}

1;
